public class Main{

public static void main(String[] args){
	float[][] ex = new float[8][256];
	float[] work = new float[256];
	float parentCost = Float.POSITIVE_INFINITY;
 FFBNet parentNet = new FFBNet(256, 6);
 Mutator mut = new Mutator(10, 25, 2 * parentNet.scale);
  for (int i = 0; i < 127; i++) {
    // Training data
    float t = (i * 2 * (float)Math.PI) / 127;
    ex[0][2 * i] = (float)Math.sin(t);
    ex[0][2 * i + 1] = (float)Math.sin(2 * t);
    ex[1][2 * i] = (float)Math.sin(2 * t);
    ex[1][2 * i + 1] = (float)Math.sin(t);
    ex[2][2 * i] = (float)Math.sin(2 * t);
    ex[2][2 * i + 1] = (float)Math.sin(3 * t);
    ex[3][2 * i] = (float)Math.sin(3 * t);
    ex[3][2 * i + 1] = (float)Math.sin(2 * t);
    ex[4][2 * i] = (float)Math.sin(3 * t);
    ex[4][2 * i + 1] = (float)Math.sin(4 * t);
    ex[5][2 * i] = (float)Math.sin(4 * t);
    ex[5][2 * i + 1] = (float)Math.sin(3 * t);
    ex[6][2 * i] = (float)Math.sin(2 * t);
    ex[6][2 * i + 1] = (float)Math.sin(5 * t);
    ex[7][2 * i] = (float)Math.sin(5 * t);
    ex[7][2 * i + 1] = (float)Math.sin(2 * t);
    
    
  }
  for (int i = 0; i < 10000; i++) {
    mut.mutate(parentNet.params);
    float cost = 0;
    for (int j = 0; j < 8; j++) {
      parentNet.recall(work, ex[(j + 1) % ex.length]);
      cost += costL2(work, ex[j]);
    }
    if (cost < parentCost) {
      parentCost = cost;
      System.out.println(parentCost);
    } else {
      mut.undo(parentNet.params);
    }
  }	
}	

public static float costL2(float[] vec, float[] tar) {
  float cost = 0;
  for (int i = 0; i < vec.length; i++) {
    float e = vec[i] - tar[i];
    cost += e * e;
  }
  return cost;
}	
}	
	
